#version 330

layout (location = 0) in vec3 position;
layout (location = 1) in vec3 normal;
layout (location = 2) in vec2 uv;

out vec3 worldNormal;
out vec2 fragmentUV;

uniform mat4 model;
uniform mat4 view_project;

void main()
{
	fragmentUV = uv; // they don't have to be transformed
	worldNormal = (model * vec4(normal,0)).xyz; // would be more complicated for non-uniform scaling
	gl_Position = view_project * model * vec4(position, 1);
}